%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1
%global debug_package %{nil}

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif
%global _prefix            /usr
%global sysconfdir         /etc
%global logdir             /var/log/svc
%global servicedir         /service

Name: pistop
Version: 1.0
Release: 1.1%{?dist}
Summary: Start/Stop services on file server startup/shutdown
%if %build_on_obs == 1
License: GPL-2.0
%else
License: GPLv2
%endif
URL: https://github.com/mbhangui/%{name}
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz

BuildRequires: gcc gcc-c++ make autoconf automake libtool
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks  
%endif
%endif
BuildRequires: libqmail-devel libqmail
Requires: user(qmaill)
Requires: group(nofiles)
Requires: daemontools ucspi-tcp coreutils util-linux rsync at
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
pistop is a package that provides two services fclient and fserver.

fclient is a svscan service that monitors the uptime of a server running
fserver service on port 5555. shutdown is detected by a socket close

fserver is a svscan service that provides a socket on port 5555 and offers
rudimentary commands.

%prep
%autosetup

%build
%configure --prefix=%{_prefix} --sysconfdir=/etc \
  --libexecdir=%{_prefix}/libexec
%{__make} -s %{?_smp_mflags}
(
echo "---------------- INFORMATION ------------------------"
echo target         %_target
echo target_alias   %_target_alias
echo target_cpu     %_target_cpu
echo target_os      %_target_os
echo target_vendor  %_target_vendor
echo Project        %{_project}
echo Building %{name}-%{version}-%{release} Build %{_build} OS %{_os}
echo "------------------------------------------------------"
) > %{name}-rpm.info

%install
[ "%{buildroot}" != "/" ] && /bin/rm -fr %{buildroot}
%{__make} -s DESTDIR=%{buildroot} install-strip
%{__mkdir_p} %{buildroot}%{sysconfdir}
install -m 0644 %{name}-rpm.info %{buildroot}%{sysconfdir}/%{name}/%{name}-rpm.info

%files
%dir %attr(755,root,root)               %{_prefix}/libexec/%{name}
%ghost %dir %attr(0755,qmaill,nofiles)  %{logdir}
%ghost      %attr(-,qmaill,nofiles)     %{logdir}/*
%license COPYING
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/pistopclient
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/pistopserver
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/pistopstart
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/host_status
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/backup
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/create_service
%attr(644,root,root)                    %{sysconfdir}/%{name}/%{name}-release
%attr(644,root,root)                    %{sysconfdir}/%{name}/%{name}-rpm.info

%attr(644,root,root)                    %{_prefix}/share/man/man1/pistopserver.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/pistopclient.1.gz

%{_prefix}/share/doc/*
%docdir %{_prefix}/share/doc/%{name}

%pretrans
# stop fclient, fserver services before upgrade
if [ -d /run ] ; then
  rundir=/run/svscan
elif [ -d /var/run ] ; then
  rundir=/var/run/svscan
else
  rundir=%{servicedir}
fi
for i in fclient fserver; do
  if [ ! -d %{servicedir}/$i ] ; then
    continue
  fi
  %{_prefix}/bin/svstat %{servicedir}/$i >/dev/null 2>&1
  if [ $? -eq 0 ] ; then
    %{__mkdir_p} ${rundir}/$i
    %{_prefix}/bin/svc -d %{servicedir}/$i
    touch ${rundir}/$i/.down
  fi
done

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 2 ] ; then # upgrade
  if [ -d /run ] ; then
    rundir=/run/svscan
  elif [ -d /var/run ] ; then
    rundir=/var/run/svscan
  else
    rundir=%{servicedir}
  fi
  # refresh fclient, fserver services
  for i in fclient fserver update; do
    if [ ! -d %{servicedir}/$i ] ; then
      continue
    fi
    # earlier installations did not have .options
    if [ ! -f %{servicedir}/$i/variables/.options ] ; then
      %{__mkdir_p} %{servicedir}/$i/variables
      options=`grep "^#" %{servicedir}/$i/run | sed -n 2p | cut -c3-`
      if [ -n "$options" ] ; then
        echo $options > %{servicedir}/$i/variables/.options
      fi
    fi
    user=`getent passwd 1000|cut -d: -f1`
    grep "\--user" %{servicedir}/$i/variables/.options >/dev/null
    if [ $? -ne 0 ] ; then
      sed -i "s/--service_name=${i}/--service_name=${i} --user=${user}/" %{servicedir}/$i/variables/.options
    fi
    %{_prefix}/sbin/minisvc --servicedir=%{servicedir} --refreshsvc="%{servicedir}/$i" --silent
    %{_prefix}/sbin/minisvc --servicedir=%{servicedir} --service-name=$i \
      --export-variables=%{servicedir}/$i/variables/.variables --force  --silent
    %{_prefix}/bin/svok %{servicedir}/$i >/dev/null 2>&1
    if [ $? -eq 0 -a -f ${rundir}/$i/.down ] ; then
      %{__rm} -f ${rundir}/$i/.down
      %{_prefix}/bin/svc -u %{servicedir}/$i
    fi
  done
  exit 0
fi
for i in fclient fserver update; do
  if [ ! -d %{servicedir}/$i ] ; then
    continue
  fi
  %{_prefix}/sbin/minisvc --servicedir=%{servicedir} --service-name=$i \
    --export-variables=%{servicedir}/$i/variables/.variables --force --silent
done

%preun
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  exit 0
fi
if [ -d %{servicedir}/fclient ] ; then
  service_name=fclient
elif [ -d %{servicedir}/fserver ] ; then
  service_name=fserver
fi
echo "removing ${service_name} logs"
log_dir=%{logdir}/${service_name}
[ "$log_dir" != "/" ] && %{__rm} -fr $log_dir
echo "stopping and removing ${service_name} service"
/usr/libexec/pistop/create_service --servicedir=%{servicedir} --service_name=${service_name} --del-service
/usr/libexec/pistop/create_service --servicedir=%{servicedir} --service_name=update --del-service
/usr/libexec/pistop/create_service --servicedir=%{servicedir} --service_name=rsync --del-service

%changelog
* Mon Jul 08 2024 02:41:45 +0000 Manvendra Bhangui <pistop@indimail.org> 1.0-1.1%{?dist}
Release 1.1 Start 30/06/2022 End --/--/----
- Initial Release
- create_service: pass -n "" for fclient to use un-encrypted channel
- pistop.spec, debian/postinst: fix variables/.options for refreshsvc
- pistopstart.in: start systemd sound.service on startup
- create_service: create MDRIVE variable for fclient, fserver
- pistopstart.in: fixed power off
- create_service: added /sbin, /usr/sbin to PATH for shutdown to work
- create_service: modified /service/fclient/shutdown to run without
  POWER_OFF env variable
- create_service: suppress error for backup dir if MDrive is not mounted
- pistopstart.in: send initializing message with hostname, data to server
- create_service.in: updated for change in tcpserver -n option
- pistopstart.in: removed hardcoded systemctl path
- pistopstart.in: increased sleep duration if disk mount fails
- pistop.spec: updated SPEC file
- create_service: kill pistopstart script if running in shutdown
- pistopstart.in: Use MDRIVE from variables if not from /etc/mpd.conf
- pistopserver.c: display IP addresses
- pistopclient.c: added more info messages
- pistopstart.in: send startup/shutdown text to lcdhost running lcdDaemon from
  lcd-daemon package
- create_service: execute $HOME/.pistop/pistopstart in shutdown script
- pistopstart.in: use /proc/loadavg instead of uptime command
- pistopstart.in: use timeout for nc command
- pistopstart.in: use LCD_HOST if defined instead of lcdhost from /etc/hosts
- create_service: added --lcdhost, --lcdport to create LCD_HOST, LCD_PORT
  env variables
- create_service: added --lcdfifo to create LCD_FIFO env variable
- host_status: script to send text to LCD display
- pistopstart.in: use host_status to send text to LCD display
- pistopserver.c: fixed shutdown
- pistopstart.in: Use umount -f -l to prevent hanging
- backup.in: transfer files with original directory into dest
- create_services.in: added more packages to UPGRADE env variable
- pistopstart.in, create_services: modified for config witout mpd
- create_services: Create FORCE_UMOUNT env variable
- pistopstart.in: Display umount method in log
- host_status.in: add delay when resetting LCD display
- host_status.in: eliminate duplicate ip addresses
- pistopstart.in: umount MDrive without triggering autofs
- pistopstart.in: ignore sigpipe
- create_services.in, host_status.in: added desktop notification to
  notifyhost or notify-fifo
- pistopstart.in: send PowerOff, MusicOff notification as desktop
  notification
- backup.in: added RSYNC_OPTIONS variable to pass options to rsync
- pistopstart.in: added more info statements
- backup.in: display rsync status on exit
